Index: bootscripts/lfs/init.d/functions
===================================================================
--- bootscripts/lfs/init.d/functions	(revision 103bbd63fe104a52e181da0653c43212b990f5e6)
+++ bootscripts/lfs/init.d/functions	(revision f874424cabc59e63f2458c25527f7c18632194a9)
@@ -13,10 +13,10 @@
 #               http://winterdrache.de/linux/newboot/index.html
 #
-#               The file should be located in /lib/boot
+#               This file is only present for backward BLFS compatibility
 #
 ########################################################################
 
 # Set any needed environment variables e.g. HEADLESS
-[ -r /etc/sysconfig/init_params ]  && . /etc/sysconfig/init_params
+. /lib/lsb/init_params
 
 ## Environmental setup
Index: bootscripts/lfs/init.d/halt
===================================================================
--- bootscripts/lfs/init.d/halt	(revision 103bbd63fe104a52e181da0653c43212b990f5e6)
+++ bootscripts/lfs/init.d/halt	(revision f874424cabc59e63f2458c25527f7c18632194a9)
@@ -6,4 +6,5 @@
 #
 # Authors     : Gerard Beekmans - gerard@linuxfromscratch.org
+#               DJ Lucas - dj@linuxfromscratch.org
 # Update      : Bruce Dubbs - bdubbs@linuxfromscratch.org
 #
Index: bootscripts/lfs/init.d/localnet
===================================================================
--- bootscripts/lfs/init.d/localnet	(revision 103bbd63fe104a52e181da0653c43212b990f5e6)
+++ bootscripts/lfs/init.d/localnet	(revision f874424cabc59e63f2458c25527f7c18632194a9)
@@ -6,4 +6,5 @@
 #
 # Authors     : Gerard Beekmans  - gerard@linuxfromscratch.org
+#               DJ Lucas - dj@linuxfromscratch.org
 # Update      : Bruce Dubbs - bdubbs@linuxfromscratch.org
 #
@@ -26,15 +27,15 @@
 ### END INIT INFO
 
-. /lib/boot/functions
-. /etc/sysconfig/network
+. /lib/lsb/init-functions
+[ -r /etc/sysconfig/network ] && . /etc/sysconfig/network
 
 case "${1}" in
    start)
-      boot_mesg "Bringing up the loopback interface..."
+      log_info_msg "Bringing up the loopback interface..."
       ip addr add 127.0.0.1/8 label lo dev lo
       ip link set lo up
       evaluate_retval
 
-      boot_mesg "Setting hostname to ${HOSTNAME}..."
+      log_info_msg "Setting hostname to ${HOSTNAME}..."
       hostname ${HOSTNAME}
       evaluate_retval
@@ -42,5 +43,5 @@
 
    stop)
-      boot_mesg "Bringing down the loopback interface..."
+      log_info_msg "Bringing down the loopback interface..."
       ip link set lo down
       evaluate_retval
@@ -64,3 +65,5 @@
 esac
 
+exit 0
+
 # End localnet
Index: bootscripts/lfs/init.d/modules
===================================================================
--- bootscripts/lfs/init.d/modules	(revision 103bbd63fe104a52e181da0653c43212b990f5e6)
+++ bootscripts/lfs/init.d/modules	(revision f874424cabc59e63f2458c25527f7c18632194a9)
@@ -6,4 +6,5 @@
 #
 # Authors     : Zack Winkles
+#               DJ Lucas - dj@linuxfromscratch.org
 # Update      : Bruce Dubbs - bdubbs@linuxfromscratch.org
 #
@@ -25,8 +26,8 @@
 ### END INIT INFO
 
-. /lib/boot/functions
-
 # Assure that the kernel has module support.
 [ -e /proc/ksyms -o -e /proc/modules ] || exit 0
+
+. /lib/lsb/init-functions
 
 case "${1}" in
@@ -34,12 +35,12 @@
       # Exit if there's no modules file or there are no
       # valid entries
-      [ -r /etc/sysconfig/modules ] &&
-         egrep -qv '^($|#)' /etc/sysconfig/modules ||
-         exit 0
+      [ -r /etc/sysconfig/modules ]                    || exit 0
+      [ $(egrep -qv '^($|#)' /etc/sysconfig/modules) ] || exit 0
 
-      boot_mesg -n "Loading modules:" ${INFO}
+      log_info_msg "Loading modules:" 
 
       # Only try to load modules if the user has actually given us
       # some modules to load.
+
       while read module args; do
 
@@ -49,12 +50,10 @@
          esac
 
-         # Attempt to load the module, making
-         # sure to pass any arguments provided.
+         # Attempt to load the module, passing any arguments provided.
          modprobe ${module} ${args} >/dev/null
 
-         # Print the module name if successful,
-         # otherwise take note.
+         # Print the module name if successful, otherwise take note.
          if [ $? -eq 0 ]; then
-            boot_mesg -n " ${module}" ${NORMAL}
+            log_info_msg2 " ${module}" 
          else
             failedmod="${failedmod} ${module}"
@@ -62,14 +61,12 @@
       done < /etc/sysconfig/modules
 
-      boot_mesg "" ${NORMAL}
-      # Print a message about successfully loaded
-      # modules on the correct line.
-      echo_ok
+      # Print a message about successfully loaded modules on the correct line.
+      log_success_msg2
 
-      # Print a failure message with a list of any
-      # modules that may have failed to load.
+      # Print a failure message with a list of any modules that 
+      # may have failed to load.
       if [ -n "${failedmod}" ]; then
-         boot_mesg "Failed to load modules:${failedmod}" ${FAILURE}
-         echo_failure
+         log_failure_msg "Failed to load modules:${failedmod}" 
+         exit 1
       fi
       ;;
@@ -81,3 +78,5 @@
 esac
 
+exit 0
+
 # End modules
Index: bootscripts/lfs/init.d/mountfs
===================================================================
--- bootscripts/lfs/init.d/mountfs	(revision 103bbd63fe104a52e181da0653c43212b990f5e6)
+++ bootscripts/lfs/init.d/mountfs	(revision f874424cabc59e63f2458c25527f7c18632194a9)
@@ -6,4 +6,5 @@
 #
 # Authors     : Gerard Beekmans - gerard@linuxfromscratch.org
+#               DJ Lucas - dj@linuxfromscratch.org
 # Update      : Bruce Dubbs - bdubbs@linuxfromscratch.org
 #
@@ -28,9 +29,9 @@
 ### END INIT INFO
 
-. /lib/boot/functions
+. /lib/lsb/init-functions
 
 case "${1}" in
    start)
-      boot_mesg "Remounting root file system in read-write mode..."
+      log_info_msg "Remounting root file system in read-write mode..."
       mount -n -o remount,rw / >/dev/null
       evaluate_retval
@@ -39,5 +40,5 @@
       rm -f /fastboot /forcefsck
 
-      boot_mesg "Recording existing mounts in /etc/mtab..."
+      log_info_msg "Recording existing mounts in /etc/mtab..."
       > /etc/mtab
 
@@ -51,13 +52,17 @@
       # This will mount all filesystems that do not have _netdev in
       # their option list.  _netdev denotes a network filesystem.
-      boot_mesg "Mounting remaining file systems..."
+
+      log_info_msg "Mounting remaining file systems..."
       mount -a -O no_netdev >/dev/null
       evaluate_retval
+      exit $failed
       ;;
 
    stop)
-      boot_mesg "Unmounting all other currently mounted file systems..."
+      # Don't unmount tmpfs like /run
+      log_info_msg "Unmounting all other currently mounted file systems..."
       umount -a -d -r -t notmpfs >/dev/null
       evaluate_retval
+      exit 0
       ;;
 
Index: bootscripts/lfs/init.d/mountvirtfs
===================================================================
--- bootscripts/lfs/init.d/mountvirtfs	(revision 103bbd63fe104a52e181da0653c43212b990f5e6)
+++ bootscripts/lfs/init.d/mountvirtfs	(revision f874424cabc59e63f2458c25527f7c18632194a9)
@@ -6,4 +6,5 @@
 #
 # Authors     : Gerard Beekmans - gerard@linuxfromscratch.org
+#               DJ Lucas - dj@linuxfromscratch.org
 # Update      : Bruce Dubbs - bdubbs@linuxfromscratch.org
 #
@@ -27,30 +28,28 @@
 ### END INIT INFO
 
-. /lib/boot/functions
+. /lib/lsb/init-functions
 
 case "${1}" in
    start)
+      # Make sure /run/var is available before logging any messages
       mkdir -p /run
       mount -n /run || failed=1
       mkdir -p /run/{var,lock,shm}
 
-
-      boot_mesg -n "Mounting virtual file systems:" ${INFO}
-      boot_mesg -n " /run" ${NORMAL}
+      log_info_msg "Mounting virtual file systems: /run" 
 
       if ! mountpoint /proc >/dev/null; then
-         boot_mesg -n " /proc" ${NORMAL}
+         log_info_msg2 " /proc"
          mount -n /proc || failed=1
       fi
 
       if ! mountpoint /sys >/dev/null; then
-         boot_mesg -n " /sys" ${NORMAL}
+         log_info_msg2 " /sys" 
          mount -n /sys || failed=1
       fi
 
-      boot_mesg "" ${NORMAL}
-
       (exit ${failed})
       evaluate_retval
+      exit $failed
       ;;
 
@@ -61,3 +60,3 @@
 esac
 
-# End mountvertfs
+# End mountvirtfs
Index: bootscripts/lfs/init.d/network
===================================================================
--- bootscripts/lfs/init.d/network	(revision 103bbd63fe104a52e181da0653c43212b990f5e6)
+++ bootscripts/lfs/init.d/network	(revision f874424cabc59e63f2458c25527f7c18632194a9)
@@ -8,4 +8,5 @@
 #               Nathan Coulson - nathan@linuxfromscratch.org
 #               Kevin P. Fleming - kpfleming@linuxfromscratch.org
+#               DJ Lucas - dj@linuxfromscratch.org
 # Update      : Bruce Dubbs - bdubbs@linuxfromscratch.org
 #
@@ -34,5 +35,5 @@
          interface=${file##*/ifconfig.}
 
-         # skip if $file is * (because nothing was found)
+         # Skip if $file is * (because nothing was found)
          if [ "${interface}" = "*" ]
          then
@@ -46,16 +47,16 @@
    stop)
       # Reverse list
-      FILES=""
+      net_files=""
       for file in  /etc/sysconfig/ifconfig.*
       do
-         FILES="${file} ${FILES}"
+         net_files="${file} ${net_files}"
       done
 
       # Stop all network interfaces
-      for file in ${FILES}
+      for file in ${net_files}
       do
          interface=${file##*/ifconfig.}
 
-         # skip if $file is * (because nothing was found)
+         # Skip if $file is * (because nothing was found)
          if [ "${interface}" = "*" ]
          then
@@ -79,3 +80,5 @@
 esac
 
+exit 0
+
 # End network
Index: bootscripts/lfs/init.d/rc
===================================================================
--- bootscripts/lfs/init.d/rc	(revision 103bbd63fe104a52e181da0653c43212b990f5e6)
+++ bootscripts/lfs/init.d/rc	(revision f874424cabc59e63f2458c25527f7c18632194a9)
@@ -1,3 +1,3 @@
-#!/bin/sh
+#!/bin/bash
 ########################################################################
 # Begin rc
@@ -6,4 +6,5 @@
 #
 # Authors     : Gerard Beekmans  - gerard@linuxfromscratch.org
+#             : DJ Lucas - dj@linuxfromscratch.org
 # Update      : Bruce Dubbs - bdubbs@linuxfromscratch.org
 #
@@ -12,43 +13,79 @@
 ########################################################################
 
-. /lib/boot/functions
+. /lib/lsb/init-functions
 
-print_error_msg()
+function print_error_msg()
 {
-   echo_failure
+   log_failure_msg
    # $i is set when called
-   boot_mesg -n "FAILURE:\n\nYou should not be reading this error message.\n\n" ${FAILURE}
-   boot_mesg -n " It means that an unforeseen error took"
-   boot_mesg -n " place in ${i}, which exited with a return value of"
-   boot_mesg " ${error_value}.\n"
-   boot_mesg_flush
-   boot_mesg -n "If you're able to track this"
-   boot_mesg -n " error down to a bug in one of the files provided by"
-   boot_mesg -n " the LFS book, please be so kind to inform us at"
-   boot_mesg " lfs-dev@linuxfromscratch.org.\n"
-   boot_mesg_flush
-   boot_mesg -n "Press Enter to continue..." ${INFO}
-   boot_mesg "" ${NORMAL}
+   MSG="FAILURE:\n\nYou should not be reading this error message.\n\n" 
+   MSG="${MSG}It means that an unforeseen error took place in\n"
+   MSG="${MSG}${i},\n"
+   MSG="${MSG}which exited with a return value of ${error_value}.\n"
+  
+   MSG="${MSG}If you're able to track this error down to a bug in one of\n"
+   MSG="${MSG}the files provided by the files provided by\n"
+   MSG="${MSG}the ${DISDRI_MINI} book, please be so kind to inform us at\n"
+   MSG="${MSG}${DISTRO_CONTACT}.\n"
+   log_failure_msg "${MSG}"
+
+   log_info_msg "Press Enter to continue..."
    wait_for_user
 }
 
-check_script_status()
+function check_script_status()
 {
    # $i is set when called
    if [ ! -f ${i} ]; then
-      boot_mesg "${i} is not a valid symlink." ${WARNING}
-      echo_warning
+      log_warning_msg "${i} is not a valid symlink." 
       continue
    fi
 
    if [ ! -x ${i} ]; then
-      boot_mesg "${i} is not executable, skipping." ${WARNING}
-      echo_warning
+      log_warning_msg "${i} is not executable, skipping."
       continue
    fi
 }
 
-# This sets a few default terminal options.
-stty sane
+function run()
+{
+   if [ -z $interactive ]; then
+      ${1} ${2}
+      return $?
+   fi
+
+   while true; do
+      read -p "Run ${1} ${2} (Yes/no/continue)? " -n 1 runit
+      echo
+
+      case ${runit} in
+         c | C)
+            interactive=""
+            ${i} ${2}
+            ret=${?}
+            break;
+            ;;
+
+         n | N)
+            return 0
+            ;;
+
+         y | Y)
+            ${i} ${2}
+            ret=${?}
+            break
+            ;;
+      esac
+   done
+
+   return $ret
+}
+
+# Read any local settings/overrides
+[ -r /etc/sysconfig/rc.site ] && source /etc/sysconfig/rc.site
+
+DISTRO=${DISTRO:-"Linux From Scratch"}
+DISTRO_CONTACT=${DISTRO_CONTACT:-"lfs-dev@linuxfromscratch.org (Registration required)"}
+DISTRO_MINI=${DISTRO_MINI:-"LFS"}
 
 # These 3 signals will not cause our script to exit
@@ -66,6 +103,25 @@
 
 if [ ! -d /etc/rc.d/rc${runlevel}.d ]; then
-   boot_mesg "/etc/rc.d/rc${runlevel}.d does not exist." 
+   log_info_msg "/etc/rc.d/rc${runlevel}.d does not exist.\n" 
    exit 1
+fi
+
+if [ "$runlevel" == "6" ] || [ "$runlevel" == "0" ]; then IPROMPT="no"; fi
+
+if [ "${IPROMPT}" == "yes" ]; then
+   # dcol and icol are spaces before the message to center the
+   # message on screen.
+
+   wcol=$(( ( ${COLUMNS} - ${wlen} ) / 2 ))
+   icol=$(( ( ${COLUMNS} - ${ilen} ) / 2 ))
+
+   echo -e "\\033[${wcol}G${welcome_message}"
+   echo -e "\\033[${icol}G${i_message}${NORMAL}"
+   echo ""
+   read -t "${itime}" -n 1 interactive 2>&1 > /dev/null
+
+   # Make lower case
+   [ "${interactive}" == "I" ] && interactive="i"
+   [ "${interactive}" != "i" ] && interactive=""
 fi
 
@@ -79,32 +135,32 @@
       suffix=${i#/etc/rc.d/rc$runlevel.d/K[0-9][0-9]}
       prev_start=/etc/rc.d/rc$previous.d/S[0-9][0-9]$suffix
-      sysinit_start=/etc/rc.d/rcsysinit.d/S[0-9][0-9]$suffix
+      sysinit_start=/etc/rc.d/rcS.d/S[0-9][0-9]$suffix
 
-      if [ "${runlevel}" != "0" ] && [ "${runlevel}" != "6" ]; then
+      if [ "${runlevel}" != "0" ]  && [ "${runlevel}" != "6" ]; then
          if [ ! -f ${prev_start} ] && [ ! -f ${sysinit_start} ]; then
-            boot_mesg -n "WARNING:\n\n${i} can't be" ${WARNING}
-            boot_mesg -n " executed because it was not"
-            boot_mesg -n " not started in the previous"
-            boot_mesg -n " runlevel (${previous})."
-            boot_mesg "" ${NORMAL}
-            boot_mesg_flush
+            MSG="WARNING:\n\n${i} can't be "
+            MSG="${MSG}executed because it was not "
+            MSG="${MSG}not started in the previous "
+            MSG="${MSG}runlevel (${previous})."
+            log_warning_msg "$MSG"
             continue
          fi
       fi
-      ${i} stop
+
+      run ${i} stop
       error_value=${?}
 
-      if [ "${error_value}" != "0" ]; then
-         print_error_msg
-      fi
+      if [ "${error_value}" != "0" ]; then print_error_msg; fi
    done
 fi
 
-if [ "${previous}" = "N" ]; then
-   IN_BOOT=1
-   export IN_BOOT
+if [ "${previous}" == "N" ]; then export IN_BOOT=1; fi
+
+if [ "$runlevel" == "6" ] && [ -n ${FASTBOOT} ]; then
+   touch /fastboot
 fi
 
-#Start all functions in this runlevel
+
+# Start all functions in this runlevel
 for i in $( ls -v /etc/rc.d/rc${runlevel}.d/S* 2> /dev/null)
 do
@@ -121,16 +177,21 @@
    case ${runlevel} in
       0|6)
-         ${i} stop
+         run ${i} stop
          ;;
       *)
-         ${i} start
+         run ${i} start
          ;;
    esac
+
    error_value=${?}
 
-   if [ "${error_value}" != "0" ]; then
-      print_error_msg
-   fi
+   if [ "${error_value}" != "0" ]; then print_error_msg; fi
 done
 
+# Copy the boot log on initial boot only
+if [ "${previous}" == "N" ]; then
+   cat /run/var/bootlog >> /var/log/boot.log
+   echo "--------" >> /var/log/boot.log  # Mark the end of boot
+fi
+
 # End rc
Index: bootscripts/lfs/init.d/reboot
===================================================================
--- bootscripts/lfs/init.d/reboot	(revision 103bbd63fe104a52e181da0653c43212b990f5e6)
+++ bootscripts/lfs/init.d/reboot	(revision f874424cabc59e63f2458c25527f7c18632194a9)
@@ -6,4 +6,5 @@
 #
 # Authors     : Gerard Beekmans - gerard@linuxfromscratch.org
+#               DJ Lucas - dj@linuxfromscratch.org
 # Update      : Bruce Dubbs - bdubbs@linuxfromscratch.org
 #
@@ -25,9 +26,9 @@
 ### END INIT INFO
 
-. /lib/boot/functions
+. /lib/lsb/init-functions
 
 case "${1}" in
    stop)
-      boot_mesg "Restarting system..."
+      log_info_msg "Restarting system..."
       reboot -d -f -i
       ;;
Index: bootscripts/lfs/init.d/sendsignals
===================================================================
--- bootscripts/lfs/init.d/sendsignals	(revision 103bbd63fe104a52e181da0653c43212b990f5e6)
+++ bootscripts/lfs/init.d/sendsignals	(revision f874424cabc59e63f2458c25527f7c18632194a9)
@@ -6,4 +6,5 @@
 #
 # Authors     : Gerard Beekmans - gerard@linuxfromscratch.org
+#               DJ Lucas - dj@linuxfromscratch.org
 # Update      : Bruce Dubbs - bdubbs@linuxfromscratch.org
 #
@@ -25,9 +26,9 @@
 ### END INIT INFO
 
-. /lib/boot//functions
+. /lib/lsb/init-functions
 
 case "${1}" in
    stop)
-      boot_mesg "Sending all processes the TERM signal..."
+      log_info_msg "Sending all processes the TERM signal..."
       killall5 -15
       error_value=${?}
@@ -36,10 +37,10 @@
 
       if [ "${error_value}" = 0 -o "${error_value}" = 2 ]; then
-         echo_ok
+         log_success_msg
       else
-         echo_failure
+         log_failure_msg
       fi
 
-      boot_mesg "Sending all processes the KILL signal..."
+      log_info_msg "Sending all processes the KILL signal..."
       killall5 -9
       error_value=${?}
@@ -48,7 +49,7 @@
 
       if [ "${error_value}" = 0 -o "${error_value}" = 2 ]; then
-         echo_ok
+         log_success_msg
       else
-         echo_failure
+         log_failure_msg
       fi
       ;;
@@ -61,3 +62,5 @@
 esac
 
+exit 0
+
 # End sendsignals
Index: bootscripts/lfs/init.d/setclock
===================================================================
--- bootscripts/lfs/init.d/setclock	(revision 103bbd63fe104a52e181da0653c43212b990f5e6)
+++ bootscripts/lfs/init.d/setclock	(revision f874424cabc59e63f2458c25527f7c18632194a9)
@@ -6,4 +6,5 @@
 #
 # Authors     : Gerard Beekmans - gerard@linuxfromscratch.org
+#               DJ Lucas - dj@linuxfromscratch.org
 # Update      : Bruce Dubbs - bdubbs@linuxfromscratch.org
 #
@@ -26,7 +27,7 @@
 ### END INIT INFO
 
-. /lib/boot/functions
+. /lib/lsb/init-functions
 
-[ -r /etc/sysconfig/clock ] &&  . /etc/sysconfig/clock
+[ -r /etc/sysconfig/clock ] && . /etc/sysconfig/clock
 
 
@@ -44,5 +45,6 @@
 case ${1} in
    start)
-      boot_mesg "Setting system clock..."
+      log_info_msg2 "\n" # Run by udev, make sure start on new line
+      log_info_msg "Setting system clock..."
       hwclock --hctosys ${CLOCKPARAMS} >/dev/null
       evaluate_retval
@@ -50,5 +52,5 @@
 
    stop)
-      boot_mesg "Setting hardware clock..."
+      log_info_msg "Setting hardware clock..."
       hwclock --systohc ${CLOCKPARAMS} >/dev/null
       evaluate_retval
@@ -57,5 +59,8 @@
    *)
       echo "Usage: ${0} {start|stop}"
+      exit 1
       ;;
 
 esac
+
+exit 0
Index: bootscripts/lfs/init.d/swap
===================================================================
--- bootscripts/lfs/init.d/swap	(revision 103bbd63fe104a52e181da0653c43212b990f5e6)
+++ bootscripts/lfs/init.d/swap	(revision f874424cabc59e63f2458c25527f7c18632194a9)
@@ -6,4 +6,5 @@
 #
 # Authors     : Gerard Beekmans - gerard@linuxfromscratch.org
+#               DJ Lucas - dj@linuxfromscratch.org
 # Update      : Bruce Dubbs - bdubbs@linuxfromscratch.org
 #
@@ -26,9 +27,9 @@
 ### END INIT INFO
 
-. /lib/boot/functions
+. /lib/lsb/init-functions
 
 case "${1}" in
    start)
-      boot_mesg "Activating all swap files/partitions..."
+      log_info_msg "Activating all swap files/partitions..."
       swapon -a
       evaluate_retval
@@ -36,5 +37,5 @@
 
    stop)
-      boot_mesg "Deactivating all swap files/partitions..."
+      log_info_msg "Deactivating all swap files/partitions..."
       swapoff -a
       evaluate_retval
@@ -48,7 +49,5 @@
 
    status)
-      boot_mesg "Retrieving swap status." ${INFO}
-      echo_ok
-      echo
+      log_success_msg "Retrieving swap status." 
       swapon -s
       ;;
@@ -60,3 +59,5 @@
 esac
 
+exit 0
+
 # End swap
Index: bootscripts/lfs/init.d/sysctl
===================================================================
--- bootscripts/lfs/init.d/sysctl	(revision 103bbd63fe104a52e181da0653c43212b990f5e6)
+++ bootscripts/lfs/init.d/sysctl	(revision f874424cabc59e63f2458c25527f7c18632194a9)
@@ -8,4 +8,5 @@
 # Authors     : Nathan Coulson (nathan@linuxfromscratch.org)
 #               Matthew Burgress (matthew@linuxfromscratch.org)
+#               DJ Lucas - dj@linuxfromscratch.org
 # Update      : Bruce Dubbs - bdubbs@linuxfromscratch.org
 #
@@ -28,10 +29,10 @@
 ### END INIT INFO
 
-. /lib/boot/functions
+. /lib/lsb/init-functions
 
 case "${1}" in
    start)
       if [ -f "/etc/sysctl.conf" ]; then
-         boot_mesg "Setting kernel runtime parameters..."
+         log_info_msg "Setting kernel runtime parameters..."
          sysctl -q -p
          evaluate_retval
@@ -49,3 +50,5 @@
 esac
 
+exit 0
+
 # End sysctl
Index: bootscripts/lfs/init.d/sysklogd
===================================================================
--- bootscripts/lfs/init.d/sysklogd	(revision 103bbd63fe104a52e181da0653c43212b990f5e6)
+++ bootscripts/lfs/init.d/sysklogd	(revision f874424cabc59e63f2458c25527f7c18632194a9)
@@ -6,4 +6,5 @@
 #
 # Authors     : Gerard Beekmans - gerard@linuxfromscratch.org
+#               DJ Lucas - dj@linuxfromscratch.org
 # Update      : Bruce Dubbs - bdubbs@linuxfromscratch.org
 #
@@ -26,27 +27,33 @@
 ### END INIT INFO
 
-. /lib/boot/functions
+. /lib/lsb/init-functions
 
 case "${1}" in
    start)
-      boot_mesg "Starting system log daemon..."
-      PARMS=${SYSKLOGD_PARMS-'-m 0'}
-      loadproc syslogd $PARMS
+      log_info_msg "Starting system log daemon..."
+      parms=${SYSKLOGD_PARMS-'-m 0'}
+      start_daemon /sbin/syslogd $parms
+      evaluate_retval
 
-      boot_mesg "Starting kernel log daemon..."
-      loadproc klogd
+      log_info_msg "Starting kernel log daemon..."
+      start_daemon /sbin/klogd
+      evaluate_retval
       ;;
 
    stop)
-      boot_mesg "Stopping kernel log daemon..."
-      killproc klogd
+      log_info_msg "Stopping kernel log daemon..."
+      killproc /sbin/klogd
+      evaluate_retval
 
-      boot_mesg "Stopping system log daemon..."
-      killproc syslogd
+      log_info_msg "Stopping system log daemon..."
+      killproc /sbin/syslogd
+      evaluate_retval
       ;;
 
    reload)
-      boot_mesg "Reloading system log daemon config file..."
-      reloadproc syslogd
+      log_info_msg "Reloading system log daemon config file..."
+      pid=`pidofproc syslogd`
+      kill -HUP "${pid}"
+      evaluate_retval
       ;;
 
@@ -57,14 +64,11 @@
       ;;
 
-   status)
-      statusproc syslogd
-      statusproc klogd
-      ;;
-
    *)
-      echo "Usage: ${0} {start|stop|reload|restart|status}"
+      echo "Usage: ${0} {start|stop|reload|restart}"
       exit 1
       ;;
 esac
 
+exit 0
+
 # End sysklogd
Index: bootscripts/lfs/init.d/template
===================================================================
--- bootscripts/lfs/init.d/template	(revision 103bbd63fe104a52e181da0653c43212b990f5e6)
+++ bootscripts/lfs/init.d/template	(revision f874424cabc59e63f2458c25527f7c18632194a9)
@@ -26,20 +26,15 @@
 ### END INIT INFO
 
-. /lib/boot/functions
+. /lib/lsb/init-functions
 
 case "${1}" in
    start)
-      boot_mesg "Starting..."
-      loadproc
+      log_info_msg "Starting..."
+      start_daemon fully_qualified_path
       ;;
 
    stop)
-      boot_mesg "Stopping..."
-      killproc
-      ;;
-
-   reload)
-      boot_mesg "Reloading..."
-      reloadproc
+      log_info_msg "Stopping..."
+      killproc fully_qualified_path
       ;;
 
@@ -50,13 +45,11 @@
       ;;
 
-   status)
-      statusproc
-      ;;
-
    *)
-      echo "Usage: ${0} {start|stop|reload|restart|status}"
+      echo "Usage: ${0} {start|stop|restart}"
       exit 1
       ;;
 esac
 
+exit 0
+
 # End scriptname
Index: bootscripts/lfs/init.d/udev
===================================================================
--- bootscripts/lfs/init.d/udev	(revision 103bbd63fe104a52e181da0653c43212b990f5e6)
+++ bootscripts/lfs/init.d/udev	(revision f874424cabc59e63f2458c25527f7c18632194a9)
@@ -6,4 +6,5 @@
 #
 # Authors     : Zack Winkles, Alexander E. Patrakov
+#               DJ Lucas - dj@linuxfromscratch.org
 # Update      : Bruce Dubbs - bdubbs@linuxfromscratch.org
 #
@@ -26,17 +27,17 @@
 ### END INIT INFO
 
-. /lib/boot/functions
+. /lib/lsb/init-functions
 
 case "${1}" in
    start)
-      boot_mesg "Populating /dev with device nodes..."
+      log_info_msg "Populating /dev with device nodes... "
       if ! grep -q '[[:space:]]sysfs' /proc/mounts; then
-         echo_failure
-         boot_mesg -n "FAILURE:\n\nUnable to create" ${FAILURE}
-         boot_mesg -n " devices without a SysFS filesystem"
-         boot_mesg -n "\n\nAfter you press Enter, this system"
-         boot_mesg -n " will be halted and powered off."
-         boot_mesg -n "\n\nPress Enter to continue..." ${INFO}
-         boot_mesg "" ${NORMAL}
+         log_failure_msg2
+         msg="FAILURE:\n\nUnable to create "
+         msg="${msg}devices without a SysFS filesystem\n\n"
+         msg="${msg}After you press Enter, this system "
+         msg="${msg}will be halted and powered off.\n\n"
+         log_info_msg "$msg"
+         log_info_msg "Press Enter to continue..."
          wait_for_user
          /etc/rc.d/init.d/halt stop
@@ -50,12 +51,13 @@
          mount -n -t tmpfs tmpfs /dev -o mode=755
       fi
+
       if [ ${?} != 0 ]; then
-         echo_failure
-         boot_mesg -n "FAILURE:\n\nCannot mount a tmpfs" ${FAILURE}
-         boot_mesg -n " onto /dev, this system will be halted."
-         boot_mesg -n "\n\nAfter you press Enter, this system"
-         boot_mesg -n " will be halted and powered off."
-         boot_mesg -n "\n\nPress Enter to continue..." ${INFO}
-         boot_mesg "" ${NORMAL}
+         log_failure_msg2
+         msg="FAILURE:\n\nCannot mount a tmpfs "
+         msg="${msg}onto /dev, this system will be halted.\n\n"
+         msg="${msg}After you press Enter, this system "
+         msg="${msg}will be halted and powered off.\n\n"
+         log_failure_msg "$msg"
+         log_info_msg "Press Enter to continue..."
          wait_for_user
          /etc/rc.d/init.d/halt stop
@@ -83,5 +85,5 @@
       # Now wait for udevd to process the uevents we triggered
       /sbin/udevadm settle
-      evaluate_retval
+      log_success_msg2 
       ;;
 
@@ -92,3 +94,5 @@
 esac
 
+exit 0
+
 # End udev
Index: bootscripts/lfs/init.d/udev_retry
===================================================================
--- bootscripts/lfs/init.d/udev_retry	(revision 103bbd63fe104a52e181da0653c43212b990f5e6)
+++ bootscripts/lfs/init.d/udev_retry	(revision f874424cabc59e63f2458c25527f7c18632194a9)
@@ -6,4 +6,5 @@
 #
 # Authors     : Alexander E. Patrakov
+#               DJ Lucas - dj@linuxfromscratch.org
 # Update      : Bruce Dubbs - bdubbs@linuxfromscratch.org
 #
@@ -27,15 +28,15 @@
 ### END INIT INFO
 
-. /lib/boot/functions
+. /lib/lsb/init-functions
 
 case "${1}" in
    start)
-      boot_mesg "Retrying failed uevents, if any..."
+      log_info_msg "Retrying failed uevents, if any..."
 
-      RUNDIR=$(/sbin/udevadm info --run)
+      rundir=$(/sbin/udevadm info --run)
       # From Debian: "copy the rules generated before / was mounted
       # read-write":
     
-      for file in ${RUNDIR}/tmp-rules--*; do
+      for file in ${rundir}/tmp-rules--*; do
          dest=${file##*tmp-rules--}
          [ "$dest" = '*' ] && break
@@ -58,3 +59,5 @@
 esac
 
+exit 0
+
 # End udev_retry
